<?php

namespace Drupal\virtual_base;

/**
 * Interface for Service VirtualBaseManager.
 */
interface VirtualBaseManagerInterface {

  /**
   * Resolves inbound path.
   *
   * @param string $path
   *   The path to process.
   * @param \Symfony\Component\HttpFoundation\Request|null $request
   *   The HttpRequest object representing the request to process. Note, if this
   *   method is being called via the path_processor_manager service and is not
   *   part of routing, the current request object must be cloned before being
   *   passed in.
   *
   * @return string
   *   The processed path.
   */
  public function resolveInboundPath($path, $request = NULL) : string;

  /**
   * Resolves Outbound path.
   *
   * @param string $path
   *   The path to process.
   * @param \Symfony\Component\HttpFoundation\Request|null $request
   *   The HttpRequest object representing the request to process. Note, if this
   *   method is being called via the path_processor_manager service and is not
   *   part of routing, the current request object must be cloned before being
   *   passed in.
   *
   * @return string
   *   The processed path.
   */
  public function resolveOutboundPath($path, $request = NULL) : string;

}
